#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=Mp3Merge.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version:   v3.3.0.0
 Script Version:   Find "dim $ScriptVersion =" to see what version we're at.

 Author:           David Leigh

 Script Function:  This script facilitates the merging of multiple MP3 files
                   into a single MP3 file.  It actually uses the DOS "copy"
				   command with the "/b" (binary) switch to do the merging.
				   That is to say, the merging is done pretty basically...no
				   magic there.  This whole script is really about how to 
				   facilitate the calling of that command easily for any
				   group of MP3 files...a gui wrapper, if you will, of that
				   command, specifically for MP3 files.
Thanks to:		   The Autoit Community for the many contributions in the
				   forum! Specifically I used some code from a call to the
				   MediaInfo dll that is mentioned here:
				   http://www.autoitscript.com/forum/index.php?showtopic=33468&st=0&gopid=671653&#entry671653
				   Also I'm using the MediaInfo DLL.  Home page here:
				   http://mediainfo.sourceforge.net	
#ce ----------------------------------------------------------------------------

;includes and initializations
#include <file.au3>
#Include <GuiListView.au3>
#Include <GuiStatusBar.au3>
#Include <GuiListBox.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListBoxConstants.au3>
#include <ProgressConstants.au3>
#include <StatusBarConstants.au3>
#include <WindowsConstants.au3>
#include <Sound.au3>
#include <Constants.au3>

;Processing options

;Declare variables
;"dim"s and variables either set here or with no initial value
dim $ScriptVersion = "1.0"
dim $OrderNum = 0
dim $szDrive, $szDir, $szFName, $szExt, $null1, $null2, $fileCount, $OutFileNameValue, $CopyCMD, $lineItem, $fileName, $dirName, $copyReturn
dim $ColWidths, $NumItems, $winsz, $hWnd, $iMsg, $iwParam, $ilParam, $TotalMs, $TotalFs, $soundID, $ItemID, $MediaInfoArray[1], $MediaInfoHandle
dim $MediaOut, $FormattedTime, $MediaArray[5], $ms, $inparm, $inmsg, $inFolder, $hndFile, $FilesArray[1], $var, $popContext, $DelLineItem
dim $tempFile = @ScriptDir & "\~mp3merge.tmp"
dim $iniFile = @ScriptDir & "\Mp3Merge.ini"
dim $iniFileLang, $nMsg

;Variables populated in the ini file
dim $DocsDir, $MMLanguage, $msgExecutionBegin, $msgExecutionEnd, $ScriptTitle, $TextViewApp, $OverwriteLog, $log, $msgMultFiles, $SaveWorkingDir
dim $msgFilesInList, $hdrColumnHeaders, $btnAdd, $btnMerge, $btnClearList, $btnExit, $btnBrowse, $dlgMp3Files, $msgTotalTime, $MediaInform, $tempInform
dim $MediaSleep, $msgTotalSize, $msgMegaBytes, $msgOpStart, $msgOpComplete, $msgAdding, $msgAddFiles, $msgNoFiles, $msgSelectFile, $msgNoOutputFile
dim $msgOverwriteIt, $msgOutputFile, $msgOverwrite, $msgFileExists, $msgInvalidOutputFile, $msgInvalidParm, $msgFolderAdded, $msgAddFileProblem, $btnHelp
dim $RelLangDir, $msgDelLineItem, $guiLogButton, $msgLineItemOrder, $msgAddedFolder, $msgAddedFile, $msgSysContextMenu, $guiSysContextMenu, $SysContextMenu

;Loop through and set variable values from the MAIN section in the ini file
$iniMain = IniReadSection($iniFile,"MAIN")
if @error Then
	MsgBox(0,$ScriptTitle,"Could not read ini file - terminating - Error: " & @error)
	Exit
EndIf
For $i = 1 To $iniMain[0][0]
	Assign($iniMain[$i][0],$iniMain[$i][1])
Next

;Set the language-specific variable
$iniFileLang = @ScriptDir & "\" & $RelLangDir & "\" & $MMLanguage & ".ini"
$iniLang = IniReadSection($iniFileLang,"MAIN")
if @error Then
	MsgBox(0,$ScriptTitle,"Could not read " & $iniFileLang & " - terminating - Error: " & @error)
	Exit
EndIf
For $i = 1 To $iniLang[0][0]
	Assign($iniLang[$i][0],$iniLang[$i][1])
Next

;Assign initial values & defaults where they didn't get assigned from the ini file
if $SaveWorkingDir = "" then $SaveWorkingDir = 1
if $DocsDir = "" then $DocsDir = @MyDocumentsDir
if $TextViewApp = "" then $TextViewApp = "Notepad.exe"
If $OverwriteLog = "" then $OverwriteLog = 1
If $log = "" Then $log = @ScriptDir & "\" & $ScriptTitle & ".log"
$TotalMs = 0

;Start logging this session
if $OverwriteLog <> 0 Then
	_FileCreate($log) ;create/overwrite the file
EndIf
_FileWriteLog($log,$msgExecutionBegin & " - " & $ScriptTitle & " - " & $ScriptVersion)

;********************************************************************************************
;* Gui Definition 
;********************************************************************************************
#Region ### START Koda GUI section ### Form=
$Mp3MergeForm = GUICreate($ScriptTitle & " - " & $ScriptVersion, 654, 500, 227, 264, BitOR($WS_EX_ACCEPTFILES,$WS_MAXIMIZEBOX,$WS_SIZEBOX,$WS_MINIMIZEBOX))
GUISetOnEvent($GUI_EVENT_CLOSE, "GetOut")
GUISetOnEvent($GUI_EVENT_MINIMIZE, "Mp3MergeFormMinimize")
GUISetOnEvent($GUI_EVENT_MAXIMIZE, "Mp3MergeFormMaximize")
GUISetOnEvent($GUI_EVENT_RESTORE, "Mp3MergeFormRestore")
$AddFile = GUICtrlCreateButton($btnAdd, 25, 24, 75, 25)
$Merge = GUICtrlCreateButton($btnMerge, 110, 24, 75, 25)
$ClearList = GUICtrlCreateButton($btnClearList, 195, 24, 75, 25)
$ViewLog = GUICtrlCreateButton($guiLogButton, 280, 24, 75, 25)
$Exit = GUICtrlCreateButton($btnExit, 365, 24, 75, 25)
$Help = GUICtrlCreateButton($btnHelp, 450, 24, 75, 25)
$OutFileName = GUICtrlCreateInput("", 24, 56, 513, 21)
$Browse = GUICtrlCreateButton($btnBrowse, 544, 54, 75, 25)
$FileList = GUICtrlCreateListView($hdrColumnHeaders, 24, 128, 593, 292, BitOR($WS_HSCROLL,$WS_VSCROLL,$LVS_EDITLABELS,$LVS_REPORT))
$popContext = GUICtrlCreateContextMenu($FileList)
$DelLineItem = GUICtrlCreateMenuitem($msgDelLineItem,$popContext)
$LineItemOrder = GUICtrlCreateMenuitem($msgLineItemOrder,$popContext)
$ProgBar = GUICtrlCreateProgress(24, 96, 590, 15)
$SysContext = GUICtrlCreateCheckbox($guiSysContextMenu, 25, 423)
if $SysContextMenu = 1 then 
	GUICtrlSetState($SysContext,$GUI_CHECKED)
	AddSysContextMenu()
Else
	GUICtrlSetState($SysContext,$GUI_UNCHECKED)
	RemoveSysContextMenu()
EndIf
GUISetHelp(@WindowsDir & "\hh.exe " & @ScriptDir & "\" & $ScriptTitle & $MMLanguage & ".chm")


$StatBar = _GUICtrlStatusBar_Create($Mp3MergeForm)
UpdateStatusBar()
#EndRegion ### END Koda GUI section ###
_GUICtrlListView_RegisterSortCallBack($FileList,1,1)
GUISetState(@SW_SHOW)

;If we passed a folder in as a command line parameter then add its contents first
;before we give things over to the user
if $CmdLine[0] > 0 Then
	$inmsg = StringReplace($msgInvalidParm,"%p",$CmdLineRaw)
	$inparm = StringSplit($CmdLine[1],"=")
	if $inparm[0] = 2 Then
		if $inparm[1] = "-addfolder" Then
			if StringRight($inparm[2],1) <> "\" then $inparm[2] &= "\" 
			_GUICtrlStatusBar_SetText($StatBar,StringReplace($msgFolderAdded,"%f",$inparm[2]))
			_FileWriteLog($log,$msgAddedFolder & " " & $inparm[2])
			AddFileClick($inparm[2])
			$inmsg = ""
		EndIf
	EndIf
	if $inmsg > "" Then _GUICtrlStatusBar_SetText($StatBar,$inmsg)
EndIf

;Basic interaction loop
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			ExitLoop
		
		Case $AddFile
			AddFileClick()
		
		Case $OutFileName
			OutFileNameChange()
		
		Case $Browse
			BrowseClick()
			
		Case $FileList
			FileListClick()
			
		Case $Merge
			MergeClick()
			
		Case $ClearList
			ClearListClick()
			
		Case $LineItemOrder
			EditLineItemOrder()

		Case $DelLineItem
			DelLineItem()
		
		Case $Help
			ShowHelp()
		
		Case $SysContext
			if GUICtrlRead($SysContext) = $GUI_CHECKED Then
				AddSysContextMenu()
			Else
				RemoveSysContextMenu()
			EndIf
		
		Case $ViewLog
			run($TextViewApp & " " & $log)
		
		Case $Exit
			ExitLoop
	EndSwitch
WEnd

GetOut()

Exit

;********************************************************************************************
;* All functions  
;********************************************************************************************

;Show the Help for Mp3Merge
Func ShowHelp()
	run(@WindowsDir & "\hh.exe " & @ScriptDir & "\" & $ScriptTitle & $MMLanguage & ".chm")
EndFunc

;Add a system context menu to the registry
Func AddSysContextMenu()
	Local $regresult
	$regresult = RegWrite("HKCR\Folder\Shell\Mp3Merge","","REG_SZ",$msgSysContextMenu)
	_FileWriteLog($log,'RegWrite("HKCR\Folder\Shell\Mp3Merge","","REG_SZ",' & $msgSysContextMenu & ') - ' & $regresult)
	local $syscontextcommand = '"' & @ScriptFullPath & '" -addfolder="%1"'
	$regresult = RegWrite("HKCR\Folder\Shell\Mp3Merge\command","","REG_SZ",$syscontextcommand)
	_FileWriteLog($log,'RegWrite("HKCR\Folder\Shell\Mp3Merge\command","","REG_SZ",' & $syscontextcommand & ') - ' & $regresult)
	$SysContextMenu = 1
	IniWrite($iniFile,"MAIN","SysContextMenu",$SysContextMenu)
EndFunc

;Remove the system context menu from the registry
Func RemoveSysContextMenu()
	Local $regresult
	$regresult = RegDelete("HKCR\Folder\Shell\Mp3Merge")
	_FileWriteLog($log,'RegDelete("HKCR\Folder\Shell\Mp3Merge") - ' & $regresult)
	$regresult = RegDelete("HKCR\Folder\Shell\Mp3Merge\command")
	_FileWriteLog($log,'RegDelete("HKCR\Folder\Shell\Mp3Merge\command") - ' & $regresult)
	$SysContextMenu = 0
	IniWrite($iniFile,"MAIN","SysContextMenu",$SysContextMenu)
EndFunc

;Delete the selected line items
Func DelLineItem()
	_GUICtrlListView_DeleteItemsSelected($FileList)
	UpdateStatusBar()
EndFunc

;Allow editing on the selected row
;the WM_NOTIFY is necessary to actually SAVE the changes made.
;in the WM_NOTIFY function, it turns itself off because when it's on
;the right-click context menu does not work!
Func EditLineItemOrder()
	GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
	_GUICtrlListView_EditLabel($FileList,_GUICtrlListView_GetNextItem($FileList))
EndFunc

;Process the addition of files into the listview via either:
;  - the open file dialog
;  - a folder name passed at script execution ($inFolder)
Func AddFileClick($inFolder = "")
	local $szDrive, $szDir, $szFName, $szExt, $patharray, $MediaDLL
	$NumItems = _GUICtrlListView_GetItemCount($FileList)
	if $inFolder = "" Then ;Get the files from the add files dialog
		$message = $msgMultFiles
		$var = FileOpenDialog($message, $DocsDir & "", $dlgMp3Files, 1 + 2 + 4 )
	Else ;Get the files from the passed in folder
		FileChangeDir($inFolder) ;set the working directory for later
		$hndFile = FileFindFirstFile($inFolder & "*.mp3")
		if @error Then
			FileClose($hndFile)
			_GUICtrlStatusBar_SetText($StatBar,StringReplace($msgAddFileProblem,"%f",$inFolder))
		Else 
			$FilesArray[0] = $inFolder
			While 1 ;loop through to populate the $FilesArray array as if it were populated from the add files dialog so that the subsequent processing works as expected
				$fileName = FileFindNextFile($hndFile)
				if @error then ExitLoop
				_ArrayAdd($FilesArray,$fileName)
			WEnd		
			FileClose($hndFile)
			if UBound($FilesArray) = 2 Then ;adjust the array if there was only one file in it so that the subsequent processing works as expected
				$FilesArray[0] = $FilesArray[0] & $FilesArray[1]
				ReDim $FilesArray[1]
			EndIf
			$var = _ArrayToString($FilesArray)
		EndIf
	EndIf
	if @error Then
	Else
		if $inFolder = "" Then
			_GUICtrlStatusBar_SetText($StatBar,$msgAddFiles)
		Else
			_GUICtrlStatusBar_SetText($StatBar,$msgAddFiles & "(" & $inFolder & ")")
		EndIf
		$DocsDir = @WorkingDir
		$FilesArray = StringSplit($var,"|")
;		_ArrayDisplay($FilesArray)
		;Loading the MediaInfo DLL
		$MediaDLL=DllOpen("MediaInfo.dll")
		if $FilesArray[0] = 1 Then
			Dim $MediaArray[5]
			$OrderNum = $OrderNum + 10
			$patharray = _PathSplit($FilesArray[1],$szDrive, $szDir, $szFName, $szExt)
			GetMediaInfo($szDrive & $szDir & $szFName & $szExt, $MediaDLL)
			$ItemID = GUICtrlCreateListViewItem($OrderNum & "|" & $szDrive & $szDir & "|" & $szFName & $szExt & "|" & $MediaArray[0] & "|" & $MediaArray[1] & "|" & $MediaArray[2] & "|" & $MediaArray[3] & "|" & $MediaArray[4],$FileList)
			_FileWriteLog($log,$msgAddedFile & " " & $szDrive & $szDir & "\" & $szFName & $szExt & " - " & $MediaArray[0] & " - " & $MediaArray[1] & " - " & $MediaArray[2] & " - " & $MediaArray[3] & " - " & $MediaArray[4])
		Else
			_ArraySort($FilesArray,0,2,0,2)
			for $i = 2 to $FilesArray[0]
				GUICtrlSetData($ProgBar,($i-1) / $FilesArray[0] * 100)
				Dim $MediaArray[5]
				$OrderNum = $OrderNum + 10
				GetMediaInfo($FilesArray[1] & "\" & $FilesArray[$i], $MediaDLL)
				$ItemID = GUICtrlCreateListViewItem($OrderNum & "|" & $FilesArray[1] & "|" & $FilesArray[$i] & "|" & $MediaArray[0] & "|" & $MediaArray[1] & "|" & $MediaArray[2] & "|" & $MediaArray[3] & "|" & $MediaArray[4],$FileList)
				_FileWriteLog($log,$msgAddedFile & " " & $FilesArray[1] & "|" & $FilesArray[$i] & " - " & $MediaArray[0] & " - " & $MediaArray[1] & " - " & $MediaArray[2] & " - " & $MediaArray[3] & " - " & $MediaArray[4])
			Next
			GUICtrlSetData($ProgBar,0)
		EndIf
		;Close the MediaInfo DLL
		DllClose($MediaDLL)	
		UpdateStatusBar()
		if $NumItems = 0 Then ;Only automatically do any re-sizing on the 1st addition of files - after that it's a user-driven manual thing
			_GUICtrlListView_SetColumnWidth($FileList,2,$LVSCW_AUTOSIZE)
			$ColWidths = 0
;			for $i = 0 to _GUICtrlListView_GetColumnCount($FileList) -1 ;ALL the columns
			for $i = 0 to 2 ;Order, directory, and file name
				$ColWidths = $ColWidths + _GUICtrlListView_GetColumnWidth($FileList,$i)
			Next
			$winsz = WinGetClientSize($ScriptTitle)
			_GUICtrlListView_SetColumnWidth($FileList,1,_GUICtrlListView_GetColumnWidth($FileList,1) + ($winsz[0] - 70 - $ColWidths))
		EndIf
	EndIf
EndFunc

;Call MediaInfo to read specific soundfile attributes
Func GetMediaInfo($SoundFile,$DLL)
	;New MediaInfo handle
	$Handle=DllCall($DLL, "ptr", "MediaInfo_New")
	;Open the media file concerned
	$Open_Result=DllCall($DLL, "int", "MediaInfo_Open", "ptr", $Handle[0], "wstr", $SoundFile)
	;Get info via MediaInfo Calls
	$Info_Get=DllCall($DLL, "wstr", "MediaInfo_Get", "ptr", $Handle[0], "int", 0, "int", 0, "wstr", "FileSize", "int", 1, "int", 0)
	$MediaArray[0] = $Info_Get[0]
	$Info_Get=DllCall($DLL, "wstr", "MediaInfo_Get", "ptr", $Handle[0], "int", 0, "int", 0, "wstr", "Duration", "int", 1, "int", 0)
	$MediaArray[1] = $Info_Get[0]
	$Info_Get=DllCall($DLL, "wstr", "MediaInfo_Get", "ptr", $Handle[0], "int", 0, "int", 0, "wstr", "BitRate", "int", 1, "int", 0)
	$MediaArray[2] = $Info_Get[0]
	$Info_Get=DllCall($DLL, "wstr", "MediaInfo_Get", "ptr", $Handle[0], "int", 0, "int", 0, "wstr", "Title", "int", 1, "int", 0)
	$MediaArray[3] = $Info_Get[0]
	$Info_Get=DllCall($DLL, "wstr", "MediaInfo_Get", "ptr", $Handle[0], "int", 0, "int", 0, "wstr", "Performer", "int", 1, "int", 0)
	$MediaArray[4] = $Info_Get[0]
	;Delete MediaInfo handle
	$Handle=DllCall($DLL, "none", "MediaInfo_Delete", "ptr", $Handle[0])
;~ 	Local $MediaOut, $line, $a, $parm
;~ 	$MediaOut = run(@ScriptDir & '\mediainfo.exe --Inform=file://' & $tempInform & ' "' & $SoundFile & '"',@ScriptDir,@SW_MINIMIZE,$STDOUT_CHILD)
;~ 	Sleep($MediaSleep) ;adjust in the ini file to find a speed that is fast enough but gives mediainfo enough time as well
;~ 	While 1
;~ 		$line = StringSplit(StdoutRead($MediaOut),@CRLF) 
;~ 		If @error Then ExitLoop
;~ ;		_ArrayDisplay($line)
;~ 		for $a = 1 to $line[0]
;~ 			Select
;~ 				Case StringInStr($line[$a],"FileSize=") > 0	
;~ 					$parm = StringSplit($line[$a],"=")
;~ 					$MediaArray[0] = $parm[2]
;~ 				Case StringInStr($line[$a],"Duration=") > 0
;~ 					$parm = StringSplit($line[$a],"=")
;~ 					$MediaArray[1] = $parm[2]
;~ 				Case StringInStr($line[$a],"BitRate=") > 0
;~ 					$parm = StringSplit($line[$a],"=")
;~ 					$MediaArray[2] = $parm[2]
;~ 				Case StringInStr($line[$a],"Title=") > 0
;~ 					$parm = StringSplit($line[$a],"=")
;~ 					$MediaArray[3] = $parm[2]
;~ 				Case StringInStr($line[$a],"Performer=") > 0
;~ 					$parm = StringSplit($line[$a],"=")
;~ 					$MediaArray[4] = $parm[2]
;~ 			EndSelect
;~ 		Next
;~ 	WEnd
EndFunc	

;Get a file name for the output file
Func BrowseClick()
	$var = StringSplit(FileOpenDialog($msgSelectFile, $DocsDir & "", $dlgMp3Files ),"|")
	GUICtrlSetData($OutFileName, $var[1])
EndFunc

;Remove ALL the items from the list
Func ClearListClick()
	_GUICtrlListView_DeleteAllItems($FileList)
	UpdateStatusBar()
EndFunc

;Put out the message on the status bar relative to the contents of the list
Func UpdateStatusBar()
	Local $NumItems, $l, $row
	$TotalMs = 0
	$TotalFs = 0
	$NumItems = _GUICtrlListView_GetItemCount($FileList)
	if $NumItems Then 
		for $l = 0 to $NumItems - 1
			$row = _GUICtrlListView_GetItem($FileList,$l,3)
			$TotalFs += $row[3]
			$row = _GUICtrlListView_GetItem($FileList,$l,4)
			$TotalMs += $row[3]
		Next
	EndIf
	$FormattedTime = MsToTime($TotalMs)
	_GUICtrlStatusBar_SetText($StatBar,$NumItems & $msgFilesInList & " - " & StringReplace($msgTotalTime,"%t",$FormattedTime) & " - " & StringReplace($msgTotalSize,"%t",Round($TotalFs/1000000,2)) & $msgMegaBytes)
EndFunc

;Convert Milliseconds to a formatted HH:MM:SS
Func MsToTime($ms)
    if $ms >= 3600000 Then; 1000*60*60 = 3600000
        $Hours = Floor($ms/3600000)
        $Rest = $ms-($Hours*3600000)
    Else
        $Hours = 0
        $Rest = $ms
    EndIf
    If $Rest >= 60000 Then; 1000*60 = 60000
        $Minutes = Floor($Rest/60000)
        $Rest = $Rest-($Minutes*60000)
    Else
        $Minutes = 0
        $Rest = $ms
    EndIf
    $Seconds = Round($Rest/1000)
    Return stringright("0" & $Hours, 2) & ":" & stringright("0" & $Minutes, 2) & ":" & stringright("0" & $Seconds, 2)
EndFunc

;Sort the list by each column
Func FileListClick()
	_GUICtrlListView_SortItems($FileList,0)
EndFunc

;Prepare to do the merging by verifying output files, etc.
Func MergeClick()
	$OutFileNameValue = GUICtrlRead($OutFileName)
	$fileCount = _GUICtrlListView_GetItemCount($FileList)
	if $fileCount = 0 Then
		_GUICtrlStatusBar_SetText($StatBar,$msgNoFiles)
		Beep(500, 250)
	Else
		if $OutFileNameValue = "" Then
			_GUICtrlStatusBar_SetText($StatBar,$msgNoOutputFile)
			Beep(500, 250)
		Else
			if FileExists($OutFileNameValue) Then
				Beep(500, 250)
				if MsgBox(4,$ScriptTitle,$msgOutputFile & ' "' & $OutFileNameValue & '"' & $msgOverwriteIt) = 6 Then
					_GUICtrlStatusBar_SetText($StatBar,$msgOverwrite)
					$MergeReturn = DoMerge()
				else
					_GUICtrlStatusBar_SetText($StatBar,$msgFileExists)
				endif
			else
				if Not _FileCreate($OutFileNameValue) Then
					Beep(500, 250)
					_GUICtrlStatusBar_SetText($StatBar,'"' & $OutFileNameValue & '" ' & $msgInvalidOutputFile)
				Else	
					$MergeReturn = DoMerge()
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc

;Actually do the merge!
Func DoMerge()
	_GUICtrlStatusBar_SetText($StatBar,$msgOpStart)
	_FileWriteLog($log,$msgOpStart)
	$copyReturn = ""
	for $i = 1 to $fileCount
		GUICtrlSetData($ProgBar,$i / $fileCount * 100)
		$lineItem = _GUICtrlListView_GetItem($FileList,$i-1,2)
		$fileName = $lineItem[3]
		$lineItem = _GUICtrlListView_GetItem($FileList,$i-1,1)
		$dirName = $lineItem[3]
		_GUICtrlStatusBar_SetText($StatBar,$msgAdding & " '" & $fileName & "'")
		_FileWriteLog($log,$msgAdding & " '" & $fileName & "' >>> '" & $OutFileNameValue & '"')
		if $i = 1 Then
			$CopyCMD = @ComSpec & " /c " & "Copy /b " & '"' & $dirName & "\" & $fileName & '" "' & $OutFileNameValue & '"'
		Else
			$CopyCMD = @ComSpec & " /c " & "Copy /b " & '"' & $OutFileNameValue & '"+"' & $dirName & "\" & $fileName & '" "' & $OutFileNameValue & '"'
		EndIf
;		InputBox("","copy this",$CopyCMD)
		$copyReturn = $copyReturn & @CRLF & $fileName & ": " & RunWait($CopyCMD,@ScriptDir,@SW_HIDE)
	Next
;	msgbox(0,"Copy results for each file",$copyReturn)
	GUICtrlSetData($ProgBar,0)
	_GUICtrlStatusBar_SetText($StatBar,$msgOpComplete)
	_FileWriteLog($log,$msgOpComplete)
EndFunc

Func Mp3MergeFormMaximize()
;currently unused
EndFunc
Func Mp3MergeFormMinimize()
;currently unused
EndFunc
Func Mp3MergeFormRestore()
;currently unused
EndFunc
Func OutFileNameChange()
;currently unused
EndFunc

;This function does all our cleanup before we exit
Func GetOut()
	_GUICtrlListView_UnRegisterSortCallBack($FileList)
	GUIDelete($Mp3MergeForm)
	if $SaveWorkingDir Then
		IniWrite($iniFile,"MAIN","DocsDir",$DocsDir)
	EndIf
	_FileWriteLog($log,$msgExecutionEnd)
	Exit
EndFunc

;This is copied from some Autoit functions to facilitate the editing of the "order" column
Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndListView, $tInfo
	$hWndListView = $FileList
	If Not IsHWnd($FileList) Then $hWndListView = GUICtrlGetHandle($FileList)
	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")
	Switch $hWndFrom
		Case $hWndListView
			Switch $iCode
			Case $LVN_BEGINLABELEDIT, $LVN_BEGINLABELEDITW ; Start of label editing for an item
					$tInfo = DllStructCreate($tagNMLVDISPINFO, $ilParam)
					Return False ; Allow the user to edit the label
					;Return True  ; Prevent the user from editing the label
				Case $LVN_COLUMNCLICK ; A column was clicked
					$tInfo = DllStructCreate($tagNMLISTVIEW, $ilParam)
					; No return value
				Case $LVN_DELETEITEM ; An item is about to be deleted
					$tInfo = DllStructCreate($tagNMLISTVIEW, $ilParam)
					; No return value
				Case $LVN_ENDLABELEDIT, $LVN_ENDLABELEDITW ; The end of label editing for an item
					$tInfo = DllStructCreate($tagNMLVDISPINFO, $ilParam)
					Local $tBuffer = DllStructCreate("char Text[" & DllStructGetData($tInfo, "TextMax") & "]", DllStructGetData($tInfo, "Text"))
					; If Text is not empty, return True to set the item's label to the edited text, return false to reject it
					; If Text is empty the return value is ignored
					; I added the following to "unregister" WM_NOTIFY because when it's "registered" then the popup context menus don't work!
					; but I need it registered for when we edit an item because the edit doesn't get saved if this doesn't execute!!!
					Local $regresult = GUIRegisterMsg($WM_NOTIFY, "")
					If StringLen(DllStructGetData($tBuffer, "Text")) Then Return True
					Case $NM_CLICK ; Sent by a list-view control when the user clicks an item with the left mouse button
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					; No return value
				Case $NM_DBLCLK ; Sent by a list-view control when the user double-clicks an item with the left mouse button
;					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					$tInfo = DllStructCreate($tagNMLVDISPINFO, $ilParam)
					Return False ; Allow the user to edit the label
					; No return value
				Case $NM_KILLFOCUS ; The control has lost the input focus
					; No return value
				Case $NM_RCLICK ; Sent by a list-view control when the user clicks an item with the right mouse button
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					;Return True ; not to allow the default processing
					Return False ; allow the default processing
				Case $NM_RDBLCLK ; Sent by a list-view control when the user double-clicks an item with the right mouse button
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					; No return value
				Case $NM_RETURN ; The control has the input focus and that the user has pressed the ENTER key
					; No return value
				Case $NM_SETFOCUS ; The control has received the input focus
					; No return value
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY